/*
 * Program to control GPIO pins.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <epivers.h>
#include <shutils.h>
#include <bcmdevs.h>
#include <bcmparams.h>
#include <bcmgpio.h>

int main(int argc, char *argv[])
{
    int gpio_pin, gpio_value;
    int need_disconnect = 0;

    if (argc < 2 || argc > 4)
    {
        printf("usage: set GPIO: gpio <pin> <value> [<need_disconnect>]\n");
        printf("       get GPIO: gpio <pin> \n");
        return -1;
    }
    
    gpio_pin = atoi(argv[1]);
    
    if (argc == 4)
        need_disconnect = atoi(argv[3]);
    
    if (argc >= 3)
    {
        gpio_value = atoi(argv[2]);
        bcmgpio_connect(gpio_pin, BCMGPIO_DIRN_OUT);
        bcmgpio_out(1 << gpio_pin , gpio_value << gpio_pin);
    }else{
        bcmgpio_connect(gpio_pin, BCMGPIO_DIRN_IN);
        bcmgpio_in(1 << gpio_pin, &gpio_value);
        printf("%d\n", gpio_value);
        //return 0;
    }
    if (need_disconnect)
        bcmgpio_disconnect(gpio_pin);

    return 0;
}
